package com.sky.ioc.service.notice.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.domain.notice.FeedBack;
import com.sky.ioc.entity.params.notice.NoticeParam;
import com.sky.ioc.mapper.notice.FeedBackMapper;
import com.sky.ioc.service.notice.FeedBackService;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Objects;

@Service
public class FeedBackServiceImpl implements FeedBackService {

    @Autowired
    FeedBackMapper feedBackMapper;


    @Override
    public ReturnMsg listPage(NoticeParam noticeParam) {
        long count = feedBackMapper.countPage(noticeParam);
        List<Map<String, Object>> lists = feedBackMapper.listPage(noticeParam);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("total",count);
        jsonObject.put("data",lists);
        return ReturnMsg.ok(jsonObject);
    }

    @Override
    public ReturnMsg readFeedBack(List<Integer> ids) {
        if(ids.size()==0||ids==null){
            return ReturnMsg.fail("参数错误");
        }else{
            feedBackMapper.updateStatusByIds(ids);
            return ReturnMsg.ok();
        }
    }

    @Override
    public ReturnMsg delFeedBack(List<Integer> ids) {
        if(ids.size()==0||ids==null){
            return ReturnMsg.fail("参数错误");
        }else{
            feedBackMapper.updateStatusByIds(ids);
            return ReturnMsg.ok();
        }
    }

    @Override
    public ReturnMsg getFeedBack(Integer id) {
        FeedBack feedBack = feedBackMapper.selectById(id);
        return ReturnMsg.ok(feedBack);
    }
}
